<?php
namespace Teknisa\CRM\Controller;

use Teknisa\CRM\Controller\TeknisaCrud;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\Remote\FileUploader\Server;


class crm30000001TipoCompromissoController extends TeknisaCrud
{
    protected $dataSourceName = 'crm_tipocompromisso';
    
    protected $zhFileUploader;
    
    public function __construct($crudService, $parameterBag, Server $zhFileUploader) {
        
		$this->zhFileUploader = $zhFileUploader;

    	parent::__construct($crudService, $parameterBag);
	}
    
    public function save(Request $request, Response $response) {
        
        $row = $request->getDataSet()->getRows()[0];
        
        if($row["__is_new"]){    
            
            $row["DSCAMINHOICONE"] = self::defineCorrectPathForUploadedImageUrl($row["DSCAMINHOICONE"]);
            
            
        }else{
            self::deleteDeletedOrReplacedImage($row);
        }

        parent::save($request, $response);
        
        $return = array();
        
        $return["DSCAMINHOICONE"] = $row["DSCAMINHOICONE"];
        
        $columnsToReturn = $this->crudService->getColumnsToReturn();
        
        if(count($columnsToReturn) > 0){  
            $return["NRTIPOCOMPROMISSO"] = $columnsToReturn[0]["NRTIPOCOMPROMISSO"];
        }
        
        $response->addDataSet(new dataSet("VALUES", $return));
    
    }
    
    public function defineCorrectPathForUploadedImageUrl($imagePath){

        if(strcmp(gettype($imagePath), "array") == 0){
            
            return $imagePath[0]["path"];
            
        }

    }
    
    public function deleteDeletedOrReplacedImage($row){

        if(gettype($row["DSCAMINHOICONE"]) == "array"){
            if(!empty($row["IMAGEURLBACKUP"])){
                $this->zhFileUploader->deleteFile($row["IMAGEURLBACKUP"]);
            }
            $row["DSCAMINHOICONE"] = self::defineCorrectPathForUploadedImageUrl($row["DSCAMINHOICONE"]);
        }else if($row["IMAGEURLBACKUP"] != $row["DSCAMINHOICONE"]){
            $this->zhFileUploader->deleteFile($row["IMAGEURLBACKUP"]);
        }
        
    }
    
    public function delete(Request $request, Response $response){
        
        $row = $request->getRow();
        
        if($row["DSCAMINHOICONE"]){
            
            $this->zhFileUploader->deleteFile($row["DSCAMINHOICONE"]);
                
        }
        
        parent::delete($request, $response);
        
    }
}