/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PROCFABRICA                                              */
/* Tabela : PROCFABRICA                                                       */
/*				                  					      */
/* Criao:                                                                   */
/* 27/09/2010 - William Azevedo de Paula                                      */
/*                                                                            */
/******************************************************************************/
   IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_PROCFABRICA' and
            type = 'TR'         and
            u.uid = o.uid       and
            u.name = USER)
   DROP TRIGGER DTULTATU_PROCFABRICA
   GO

CREATE TRIGGER DTULTATU_PROCFABRICA
ON PROCFABRICA 
FOR INSERT,UPDATE,DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                              (SELECT 'PROCFABRICA', NULL,  'CDPROCFABRIC=' + CDPROCFABRIC +';
                                                    CDPRODUTO   ='+ CDPRODUTO   +';', GETDATE()FROM DELETED);
   END
   ELSE BEGIN
      UPDATE PROCFABRICA
      SET DTULTATUPFAB = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(PROCFABRICA.IDPROFABPADR,0) = ISNULL(INSERTED.IDPROFABPADR,0)) OR
            (ISNULL(PROCFABRICA.QTPADPROCFAB,0) = ISNULL(INSERTED.QTPADPROCFAB,0));
         
     
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_PROCFABRICA','4.10.080';
GO