/* Sistemas Integrados TECNISA

Nome: DTULTATU_MOTIVOOPER

Descrio:

Atualiza a data de ultima atualizao da tabela MOTIVOOPER

Criao:
15/01/2009 Frederico Gonalves Moreira da Costa
*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_MOTIVOOPER' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_MOTIVOOPER
GO

CREATE TRIGGER DTULTATU_MOTIVOOPER
ON MOTIVOOPER
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'MOTIVOOPER',NULL,'CDEMPRESA='+CDEMPRESA+';'+'CDMOTIVOOPER='+CDMOTIVOOPER+';',
                               GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE MOTIVOOPER
      SET DTULTATUMOPER = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(REGIMEBEM.CDEMPRESA,0) = ISNULL(INSERTED.CDEMPRESA,0)) AND
            (ISNULL(REGIMEBEM.CDMOTIVOOPER,0) = ISNULL(INSERTED.CDMOTIVOOPER,0)) AND
            (ISNULL(REGIMEBEM.NMMOTIVOOPER,0) = ISNULL(INSERTED.NMMOTIVOOPER,0)) AND
            (ISNULL(REGIMEBEM.NMABREVMOTOPER,0) = ISNULL(INSERTED.NMABREVMOTOPER,0)) AND
            (ISNULL(REGIMEBEM.IDVENDAMOTOPER,0) = ISNULL(INSERTED.IDVENDAMOTOPER,0)) AND
            (ISNULL(REGIMEBEM.DSOBSMOTIVOOPER,0) = ISNULL(INSERTED.DSOBSMOTIVOOPER,0)) AND
            (ISNULL(REGIMEBEM.CDOPERATUMOPER,0) = ISNULL(INSERTED.CDOPERATUMOPER,0));
   END;
END;
GO