<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;

use HCM\Util\Repositories;

class EsoPeriodico extends \Doctrine\ORM\EntityRepository {
    
    public function getEnviosEvento($nrorg, $nmevento, $nrestruturam, $nrtpambiente, $dtmescompetenc, $idativo = 'S', $nrchave = null, $nrtabela = null, $idoperacao = array(), $nrenvioexcl=null) {
        try{
            $esoPeriodico = Repositories::ESO_PERIODICO;
            $esoEvento = Repositories::ESO_EVENTO;
            
            $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
            $params = array(
                'nrorg' => $nrorg,
                'nmevento' => $nmevento,
                'nrestruturam' => $nrestruturam,
                'nrtpambiente' => $nrtpambiente,
                'dtmescompetenc' => $dtmescompetenc,
                'idativo' => $idativo,
                'nrchave' => $nrchave,
                'nrtabela' => $nrtabela,
                'nrenvioexcl' => $nrenvioexcl,
            );
            $sql = "SELECT envio
                      FROM $esoPeriodico envio
                     WHERE envio.nrorg = :nrorg
                       AND envio.nmevento = :nmevento
                       AND (envio.nrestruturam = :nrestruturam OR (envio.nrestruturam <> :nrestruturam AND envio.nmevento IN ('S-2205','S-2206','S-2306'))) 
                       AND envio.nrtpambiente = :nrtpambiente
                       AND envio.dtmescompetenc = :dtmescompetenc
                       AND envio.idativo = :idativo
                       AND (envio.nrchave = :nrchave OR :nrchave IS NULL)
                       AND (envio.nrtabela = :nrtabela OR :nrtabela IS NULL)
                       AND ((:nrenvioexcl = 'S' AND envio.nrenvioexcl IS NOT NULL) OR (:nrenvioexcl = 'N' AND envio.nrenvioexcl IS NULL) OR :nrenvioexcl IS NULL)";
            
            if (!empty($idoperacao)) {
                $sql .= " AND (envio.idoperacao IN ('".implode("','",$idoperacao)."'))";
            }
           
            return $this->getEntityManager()->createQuery($sql)->execute($params);
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    public function getVinculosAtivosSemLiquidoFechamento($nrorg, $dtmescompetenc, $nrtpmodalidcal, $nrtipomoviment, $dtocorrencia, $nreventom, $nrestrutlegal) {
        try{
            $db  = \Setforms2\Shared\Registry::getEntityManagerConnection();
            $sql = "SELECT VM.NMVINCULOM, VM.NRVINCULOM, CF.NRORG, VH.DTMESCOMPETENC, CF.NRTPMODALIDCAL, CF.NRTIPOMOVIMENT, CF.DTOCORRENCIA, IC.NREVENTOM, VH.NRESTRUTLEGAL
                      FROM FPA_CALCULOFOLHA CF
                      JOIN FPA_ITECALCFOLHA IC ON IC.NRORG = CF.NRORG
                                          AND IC.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
                      JOIN GPE_VINCULOM VM ON VM.NRORG = IC.NRORG
                                          AND VM.NRVINCULOM = IC.NRVINCULOM
                      JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                                          AND VH.NRVINCULOM = VM.NRVINCULOM
                                          AND VH.DTMESCOMPETENC = ( SELECT * FROM ( SELECT VH1.DTMESCOMPETENC FROM GPE_VINCULOH VH1
                                                                     WHERE VH1.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                                       AND VH1.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(:P_DTMESCOMPETENC),'YEAR'),-12)
                                                                       AND VH1.NRORG      = VM.NRORG
                                                                       AND VH1.NRVINCULOM = VM.NRVINCULOM
                                                                       ORDER BY DTMESCOMPETENC DESC )
                                                                      WHERE ROWNUM = 1 )
                                                        /*↑↑↑ Otimização de Query João Victor Martins 20/09/2023 ↑↑↑*/
                            WHERE CF.NRORG = :P_NRORG
                              AND CF.NRTPMODALIDCAL = :P_NRTPMODALIDCAL
                              AND CF.NRTIPOMOVIMENT = :P_NRTIPOMOVIMENT
                              AND CF.DTOCORRENCIA = :P_DTOCORRENCIA
                              AND IC.NREVENTOM = :P_NREVENTOM
                              AND VH.NRESTRUTLEGAL = :P_NRESTRUTLEGAL
                              AND NOT EXISTS (SELECT 1 FROM FPA_ITECALCFOLHA I
                                               WHERE I.NRORG = IC.NRORG
                                                 AND I.NRCALCULOFOLHA = IC.NRCALCULOFOLHA
                                                 AND I.NRVINCULOM = IC.NRVINCULOM
                                                 AND I.NREVENTOM = 3035)";
            
            $params = array(
                "P_NRORG" => $nrorg,
                "P_DTMESCOMPETENC" => $dtmescompetenc,
                "P_NRTPMODALIDCAL" => $nrtpmodalidcal,
                "P_NRTIPOMOVIMENT" => $nrtipomoviment,
                "P_DTOCORRENCIA" => $dtocorrencia,
                "P_NREVENTOM" => $nreventom,
                "P_NRESTRUTLEGAL" => $nrestrutlegal,
            );
            return $db->fetchAll($sql, $params);
        }catch (Exception $e) {
            throw $e;
        }
    }


    public function getVinculosRescindidosSemEvento($nrtipoambiente, $nrorg, $dtmescompetenc, $nrtpmodalidcal, $nrtipomoviment, $nrtabela, $nreventom, $cdcnpjempregador ) {
            try{
                
                $db  = \Setforms2\Shared\Registry::getEntityManagerConnection();
                $sql = "SELECT
                            VM.NRVINCULOM,
                            VM.NMVINCULOM,
                            ESONP.NRENVIO
                        FROM
                                 FPA_CALCULOFOLHA CF
                            JOIN FPA_ITECALCFOLHA IC ON IC.NRORG = CF.NRORG
                                                        AND IC.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
                            JOIN GPE_VINCULOM     VM ON VM.NRORG = IC.NRORG
                                                    AND VM.NRVINCULOM = IC.NRVINCULOM
                            JOIN GPE_VINCULOH     VH ON VH.NRORG = VM.NRORG
                                                    AND VH.NRVINCULOM = VM.NRVINCULOM
                                                    AND VH.DTMESCOMPETENC = (
                                SELECT
                                    MAX(H1.DTMESCOMPETENC)
                                FROM
                                    GPE_VINCULOH H1
                                WHERE
                                        H1.NRORG = VH.NRORG
                                    AND H1.NRVINCULOM = VH.NRVINCULOM
                                    AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                            )
                            LEFT JOIN ESO_NAOPERIODICO ESONP ON ESONP.NRORG = VM.NRORG
                                                                AND TRUNC(ESONP.DTMESCOMPETENC, 'MM') = :P_DTMESCOMPETENC
                                                                AND ESONP.NRTPAMBIENTE = :P_NRTPAMBIENTE
                                                                AND ESONP.IDATIVO = 'S'
                                                                AND ESONP.NRENVIOEXCL IS NULL
                                                                AND ESONP.IDSTATUS IN ( 'C', 'A', 'M' )
                                                                AND ESONP.NMEVENTO IN ( 'S-2299', 'S-2399' )
                                                                AND ESONP.NRVINCULOM = VM.NRVINCULOM
                                                                AND ( ESONP.NRTABELA = :P_NRTABELA
                                                                      OR ( :P_NRTABELA = 1
                                                                           AND ESONP.NRTABELA IS NULL )
                                                                      OR :P_NRTABELA IS NULL )
                            LEFT JOIN ESTRUTURAH EVH ON EVH.NRORG = ESONP.NRORG
                                            AND EVH.NRESTRUTURAM = ESONP.NRESTRUTURAM
                                            AND SUBSTR(EVH.CDCNPJESTRUT,1,8) = SUBSTR(:P_CDCNPJEMPREGADOR,1,8)
                                            AND EVH.DTMESCOMPETENC = (SELECT MAX(H1.DTMESCOMPETENC) FROM ESTRUTURAH H1
                                                                       WHERE H1.NRORG = EVH.NRORG
                                                                         AND H1.NRESTRUTURAM = EVH.NRESTRUTURAM
                                                                         AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
                                            WHERE CF.NRORG = :P_NRORG
                                              AND CF.NRTPMODALIDCAL = :P_NRTPMODALIDCAL
                                              AND CF.NRTIPOMOVIMENT = :P_NRTIPOMOVIMENT
                                              AND CF.DTOCORRENCIA = :P_DTMESCOMPETENC
                                              AND IC.NREVENTOM = :P_NREVENTOM";
                
                $params = array(
                    "P_NRORG" => $nrorg,
                    "P_DTMESCOMPETENC" => $dtmescompetenc,
                    "P_NRTPMODALIDCAL" => $nrtpmodalidcal,
                    "P_NRTIPOMOVIMENT" => $nrtipomoviment,
                    "P_NREVENTOM" => $nreventom,
                    "P_CDCNPJEMPREGADOR" => $cdcnpjempregador,
                    "P_NRTPAMBIENTE" => $nrtipoambiente,
                    "P_NRTABELA" => $nrtabela,
                );
                return $db->fetchAll($sql, $params);
            }catch (Exception $e) {
                throw $e;
            }
        }
    }
