function ABAgendaDeTarefasController(CRM_Utilities, templateManager) {
    
    /**
     * Define o filtro da widget de tarefas
     * de acordo com a campanha selecionada
     * (Tela 'Campanha Tarefas').
     * 
     * @param {object} campaignWidget widget de campanhas.
    */
    this.setTasksWidgetFilterByCampaignNumber = function(campaignWidget){
        
        var currentCampaign = campaignWidget.currentRow;
        var tasksWidget = templateManager.container.getWidget('Agenda');
        
        var nrseqcampanhaFilterIndex = CRM_Utilities.getObjectPositionInArrayByName(tasksWidget.dataSourceFilter, "NRSEQCAMPANHA");
        
        tasksWidget.dataSourceFilter[nrseqcampanhaFilterIndex].value = currentCampaign.NRSEQCAMPANHA;
        
        tasksWidget.reload();
        
    };
    
    /**
     * Define o filtro de uma widget
     * de evolução.
     * 
     * @param {object} widget widget de evolução.
    */
    this.setEvolutionWidgetfilter = function(){
        
        var evolutionWidget = templateManager.container.getWidget("evolucao");
        var widgetFilter = evolutionWidget.dataSourceFilter;
        
        widgetFilter[0].value = evolutionwidget.getParent().currentRow.NRPARCNEGOCIO;
        
        evolutionWidget.reload();
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ABAgendaDeTarefasController', ABAgendaDeTarefasController);
});