var ger01900_cadastroproduto_controller = function (ScreenService, ProdutoService, General, templateManager, CRM_Utilities) {

	var parent = this;


	this.filtraArvProduto = function (widget) {
		if (widget.mode !== 'edit' && widget.mode !== 'view') {

			var cdproduto = widget.parent.parent.currentRow.CDPRODUTO;
			var filtro = [
				{
					"name": "CDPRODUTO",
					"operator": "=",
					"value": cdproduto
                }
            ];
			widget.dataSourceFilter = filtro;
			widget.reload();
			widget.activate();

		}
	};

	this.onChangeTipoArv = function (field) {
		var value = field.value();
		if (!Util.isEmptyOrBlank(value)) {
			var nrtparvprod = field.widget.currentRow.NRTPARVPROD;
			field.widget.getField('NMARVOREPROD').dataSourceFilter = [
				{
					"name": "NRTPARVPROD",
					"operator": "=",
					"value": nrtparvprod
                }
            ];
			field.widget.getField('NMARVOREPROD').reload().then(function () {
				field.widget.getField('NMARVOREPROD').readOnly = false;
				field.widget.getField("NMARVOREPROD").validations = {
					"required": true
				};
			});
		} else {
			field.widget.getField('NMARVOREPROD').readOnly = true;
			field.widget.getField('NMARVOREPROD').value('');
			field.widget.getField("NMARVOREPROD").validations = undefined;
		}
	};

	this.saveProduto = function (widget) {
		
		var currentRow = widget.currentRow;
        CRM_Utilities.setColumnToReturnInCurrentRow(currentRow, "CDPRODUTO");
		
		if(widget.isValid()){
			General.widgetSave(widget).then(function (success) {
				widget.dataSourceFilter.push({
					"name":"CDPRODUTO",
					"operator":"=",
					"value": success.dataset.columnsToReturn[0].CDPRODUTO
				});
				widget.reload().then(function () {
					widget.dataSourceFilter.pop();
				});
			}).catch(function(err) {
				ScreenService.showMessage(err.data.error);
			});
			
		}

	};

	this.saveProdutoArvoreProduto = function (widget) {
		if (widget.isValid()) {
			var row = widget.currentRow;
			ProdutoService.saveProdArvProd(row).then(function (success) {
				ScreenService.showMessage('Salvo com sucesso!');
				General.changeWidgetAcessibility(widget.widgets, true);
				widget.reload().then(function () {
					widget.view();
					ScreenService.closeSwipe();
					widget.getField('NMARVOREPROD').readOnly = true;
					widget.getField('NMARVOREPROD').value('');
					widget.getField("NMARVOREPROD").validations = undefined;
				});
			}, function (err) {
				ScreenService.showMessage(err.data.error);
			});
		}
	};

};

Configuration(function (ContextRegister, eventEngine) {
	ContextRegister.register('ger01900_cadastroproduto_controller', ger01900_cadastroproduto_controller);
});